/*
LaserOutputDlg.cpp : implementation file

Copyright (c) 2009 Chris Favreau

Permission is hereby granted, free of charge, to any person
obtaining a copy of this software and associated documentation
files (the "Software"), to deal in the Software without
restriction, including without limitation the rights to use,
copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the
Software is furnished to do so, subject to the following
conditions:

The above copyright notice and this permission notice shall be
included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
OTHER DEALINGS IN THE SOFTWARE.
*/

#include "stdafx.h"
#include "OpenLaserShowController.h"
#include "LaserOutputDlg.h"


// CLaserOutputDlg dialog

IMPLEMENT_DYNAMIC(CLaserOutputDlg, CDialog)

CLaserOutputDlg::CLaserOutputDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CLaserOutputDlg::IDD, pParent)
{
	m_bInitialized = false;
}

CLaserOutputDlg::~CLaserOutputDlg()
{
}

void CLaserOutputDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}


BEGIN_MESSAGE_MAP(CLaserOutputDlg, CDialog)
	ON_WM_SIZE()
	ON_WM_CREATE()
END_MESSAGE_MAP()


// CLaserOutputDlg message handlers

BOOL CLaserOutputDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Initialize the Vector Display
	m_display.Init();
	CRect temp_rect;
	GetClientRect(&temp_rect);

	m_display.Create(WS_CHILD | WS_VISIBLE, temp_rect, this, 0);
	m_display.SetRectangle(temp_rect);
	m_display.ShowWindow(SW_SHOW);

	m_bInitialized = true;

	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}

void CLaserOutputDlg::SetDisplayCount(int number_of_displays)
{
	// TODO - set the number of vector displays to put in this dialog window
}

void CLaserOutputDlg::WriteFrame(LASER_SHOW_DEVICE_FRAME frame)
{
	// Pass the frame to the vector display
	m_display.SetPointList(frame);
	m_display.Invalidate();
}


void CLaserOutputDlg::OnSize(UINT nType, int cx, int cy)
{
	CDialog::OnSize(nType, cx, cy);

	if (!m_bInitialized) return;

	// Resize the vector display to fit the dialog window
	CRect temp_rect;
	GetClientRect(&temp_rect);
	m_display.SetRectangle(temp_rect);
	m_display.SetWindowPos(NULL, temp_rect.left, temp_rect.top, temp_rect.Width(), temp_rect.Height(), 0);
	m_display.Invalidate();
}

int CLaserOutputDlg::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CDialog::OnCreate(lpCreateStruct) == -1)
		return -1;

	// Keep this dialog window on top ALWAYS
	this->SetWindowPos(&CWnd::wndTopMost,0,0,0,0,SWP_NOMOVE|SWP_NOSIZE);

	return 0;
}
