/*
**********************************************
** Vector Display Control
**
***********************************************

Copyright (c) 2009 Chris Favreau

Permission is hereby granted, free of charge, to any person
obtaining a copy of this software and associated documentation
files (the "Software"), to deal in the Software without
restriction, including without limitation the rights to use,
copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the
Software is furnished to do so, subject to the following
conditions:

The above copyright notice and this permission notice shall be
included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
OTHER DEALINGS IN THE SOFTWARE.
*/

#include "OpenLaserShowController.h"

#define MAX_FRAME_SIZE	16384

class CVectorDisplayCtrl : public  CWnd
{
private:
	bool m_bDisplayFrame;
	bool m_bEraseBackground;
	
	LASER_SHOW_DEVICE_FRAME m_frame;
	
	CRect m_rectDisplay;

	double dXPointsPerPixel;
	double dYPointsPerPixel;

public:
	CVectorDisplayCtrl();
	~CVectorDisplayCtrl();
	virtual BOOL Create(DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID=NULL);
	void Init();
	void SetRectangle(CRect control_rect);
	void DrawDisplay(CDC *pDC);
	
	void SetPointList(LASER_SHOW_DEVICE_FRAME frame);
	
	//{{AFX_MSG(CVectorDisplayCtrl)
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnPaint();
	afx_msg BOOL OnEraseBkgnd(CDC* pDC);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};